IMPLEMENTATION MODULE jump;
__IMP_SWITCHES__
#ifdef HM2
#ifdef __LONG_WHOLE__
(*$!i+: Modul muss mit $i- uebersetzt werden! *)
(*$!w+: Modul muss mit $w- uebersetzt werden! *)
#else
(*$!i-: Modul muss mit $i+ uebersetzt werden! *)
(*$!w-: Modul muss mit $w+ uebersetzt werden! *)
#endif
#endif
(*****************************************************************************)
(* 01-Jan-94, Holger Kleinschmidt                                            *)
(*****************************************************************************)

INLINE_CODE_IMPORT


FROM PORTAB IMPORT
(* TYPE *) UNSIGNEDWORD;

FROM OSCALLS IMPORT
(* PROC *) Psigreturn;

FROM DosSystem IMPORT
(* PROC *) MiNTVersion;

(*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*)

VAR
  MiNT : BOOLEAN;

(*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*)

#if (defined LPRM2) || (defined SPCM2)
PROCEDURE setjmp ((* -- /AUS *) VAR env : JmpBuf ): INTEGER;
(*T*)
BEGIN
(*
setjmp:
  movea.l (SP)+,A6      ; A6 -> lokale Variablen des Aufrufers
  movea.l (SP)+,A4      ; A4 -> globale Variablen des Aufrufers
  movea.l (SP)+,A1      ; A1 := RTN-Adresse
  movea.l (SP)+,A0      ; A0 -> <env>
; Parameter, Link und RTN-Adresse sind jetzt vom Stack abgeraeumt
  movem.l A1/A4-A7,(A0) ; Register und RTN-Adr. in <env> sichern
  clr.w   (SP)          ; Funktionswert := 0
  jmp     (A1)          ; zurueck zum Aufrufer
*)
 INLINE(2C5FH);
 INLINE(285FH);
 INLINE(225FH);
 INLINE(205FH);
 INLINE(48D0H,0F200H);
 INLINE(4257H);
 INLINE(4ED1H);
END setjmp;

(*----------------------------------------------------------------------------*)

PROCEDURE longjmp ((* EIN/ -- *) VAR env : JmpBuf;
                   (* EIN/ -- *)     val : INTEGER );
(*T*)
BEGIN
 IF MiNT THEN
   Psigreturn;
 END;
(*
longjmp:
  movea.l 12+2(A6),A0   ; A0 -> <env>
  move.w  12(A6),D0     ; D0 := <val>
  bne.s   setregs       ; B: Wert <> Null uebernehmen
  moveq   #1,D0         ; Wert Null auf eins korrigieren
setregs:
  movem.l (A0),A1/A4-A7 ; Register auf Wert vor "setjmp()"
  move.w  D0,(SP)       ; Funktionswert := <val>
  jmp     (A1)          ; zurueck wie nach "setjmp()"-Aufruf
*)
 INLINE(206EH,000EH);
 INLINE(302EH,000CH);
 INLINE(6602H);
 INLINE(7001H);
 INLINE(4CD0H,0F200H);
 INLINE(3E80H);
 INLINE(4ED1H);
END longjmp;

(*----------------------------------------------------------------------------*)

PROCEDURE sigsetjmp ((* -- /AUS *) VAR env      : SigJmpBuf;
                     (* EIN/ -- *)     savemask : UNSIGNEDWORD ): INTEGER;
(**)
BEGIN
 RETURN(-1);
END sigsetjmp;

(*----------------------------------------------------------------------------*)

PROCEDURE siglongjmp ((* EIN/ -- *) VAR env : SigJmpBuf;
                      (* EIN/ -- *)     val : INTEGER   );
(**)
BEGIN
END siglongjmp;

#elif (defined HM2)
__PROCFRAME_OFF__
PROCEDURE setjmp ((* -- /AUS *) VAR env : JmpBuf ): INTEGER;
(*T*)
BEGIN
(*
setjmp:
  movea.l (SP)+,A1         ; A1 := RTN-Adresse
  movea.l (SP)+,A0         ; A0 -> <env>
; Parameter und RTN-Adresse sind jetzt vom Stack abgeraeumt
  movem.l D2-D7/A1-A7,(A0) ; Register und RTN-Adr. in <env> sichern
  moveq   #0,D0            ; Funktionswert := 0
  jmp     (A1)             ; zurueck zum Aufrufer
*)
 CODE(225FH);
 CODE(205FH);
 CODE(48D0H,0FEFCH);
 CODE(7000H);
 CODE(4ED1H);
END setjmp;
__PROCFRAME_ON__
(*----------------------------------------------------------------------------*)
__PROCFRAME_OFF__
PROCEDURE longjmp ((* EIN/ -- *) VAR env : JmpBuf;
                   (* EIN/ -- *)     val : INTEGER );
(*T*)
BEGIN
 IF MiNT THEN
   Psigreturn;
 END;
(*
longjmp:
  movea.l 4(SP),A0      ; A0 -> <env>
#ifdef __LONG_WHOLE__
  move.l  8(SP),D0      ; D0 := <val>
#else
  move.w  8(SP),D0      ; D0 := <val>
#endif
  bne.s   setregs       ; B: Wert <> Null uebernehmen
  moveq   #1,D0         ; Wert Null auf eins korrigieren
setregs:
  movem.l (A0),D2-D7/A1-A7 ; Register auf Wert vor "setjmp()"
  jmp     (A1)          ; zurueck wie nach "setjmp()"-Aufruf
*)
 CODE(206FH,0004H);
#ifdef __LONG_WHOLE__
 CODE(202FH,0008H);
#else
 CODE(302FH,0008H);
#endif
 CODE(6602H);
 CODE(7001H);
 CODE(4CD0H,0FEFCH);
 CODE(4ED1H);
END longjmp;
__PROCFRAME_ON__

(*----------------------------------------------------------------------------*)

PROCEDURE sigsetjmp ((* -- /AUS *) VAR env      : SigJmpBuf;
                     (* EIN/ -- *)     savemask : UNSIGNEDWORD ): INTEGER;
(**)
BEGIN
 RETURN(-1);
END sigsetjmp;

(*----------------------------------------------------------------------------*)

PROCEDURE siglongjmp ((* EIN/ -- *) VAR env : SigJmpBuf;
                      (* EIN/ -- *)     val : INTEGER   );
(**)
BEGIN
END siglongjmp;

#elif (defined TDIM2)

__PROCFRAME_OFF__
PROCEDURE setjmp ((* -- /AUS *) VAR env : JmpBuf ): INTEGER;
(*T*)
BEGIN
(*
setjmp:
  movea.l (SP)+,A1      ; A1 := RTN-Adresse
  movea.l (SP),A0       ; A0 -> <env>, nicht abraeumen, macht Aufrufer
; RTN-Adresse ist jetzt vom Stack abgeraeumt
  movem.l A1/A5-A7,(A0) ; Register und RTN-Adr. in <env> sichern
  clr.w   4(SP)         ; Funktionswert := 0
  jmp     (A1)          ; zurueck zum Aufrufer
*)
 CODE(225FH);
 CODE(2057H);
 CODE(48D0H,0E200H);
 CODE(426FH,0004H);
 CODE(4ED1H);
END setjmp;
__PROCFRAME_ON__
(*----------------------------------------------------------------------------*)
__PROCFRAME_OFF__
PROCEDURE longjmp ((* EIN/ -- *) VAR env : JmpBuf;
                   (* EIN/ -- *)     val : INTEGER );
(*T*)
BEGIN
 IF MiNT THEN
   Psigreturn;
 END;
(*
longjmp:
  movea.l 4+2(SP),A0    ; A0 -> <env>
  move.w  4(SP),D0      ; D0 := <val>
  bne.s   setregs       ; B: Wert <> Null uebernehmen
  moveq   #1,D0         ; Wert Null auf eins korrigieren
setregs:
  movem.l (A0),A1/A5-A7 ; Register auf Wert vor "setjmp()"
  move.w  D0,4(SP)      ; Funktionswert := <val>
  jmp     (A1)          ; zurueck wie nach "setjmp()"-Aufruf
*)
 CODE(206FH,0006H);
 CODE(302FH,0004H);
 CODE(6602H);
 CODE(7001H);
 CODE(4CD0H,0E200H);
 CODE(3F40H,0004H);
 CODE(4ED1H);
END longjmp;
__PROCFRAME_ON__

(*----------------------------------------------------------------------------*)

PROCEDURE sigsetjmp ((* -- /AUS *) VAR env      : SigJmpBuf;
                     (* EIN/ -- *)     savemask : UNSIGNEDWORD ): INTEGER;
(**)
BEGIN
 RETURN(-1);
END sigsetjmp;

(*----------------------------------------------------------------------------*)

PROCEDURE siglongjmp ((* EIN/ -- *) VAR env : SigJmpBuf;
                      (* EIN/ -- *)     val : INTEGER   );
(**)
BEGIN
END siglongjmp;


#elif (defined MM2)

__PROCFRAME_OFF__
PROCEDURE setjmp ((* -- /AUS *) VAR env : JmpBuf ): INTEGER;
(**)
BEGIN
 ASSEMBLER
   MOVEA.L (A7)+,A1            ; A1 := RTN-Adresse und vom Stack abraeumen
   MOVEA.L -(A3),A0            ; A0 -> <env>
   MOVEM.L D3-D7/A1/A3-A7,(A0) ; Register und RTN-Adr. in <env> sichern
   MOVEQ   #0,D0               ; Funktionswert := 0
#ifdef __RES_ON_STACK__
#ifdef __LONG_WHOLE__
   MOVE.L  D0,(A3)+            ; Funktionswert := 0
#else
   MOVE.W  D0,(A3)+            ; Funktionswert := 0
#endif
#endif
   JMP     (A1)                ; zurueck zum Aufrufer
 END;
(*
(*
setjmp:
  movea.l -(A3),A0            ; A0 -> <env>
  movea.l (SP)+,A1            ; A1 := RTN-Adresse und vom Stack abraeumen
  movem.l D3-D7/A1/A3-A7,(A0) ; Register und RTN-Adr. in <env> sichern
  moveq   #0,D0               ; Funktionswert := 0
#ifdef __RES_ON_STACK__
#ifdef __LONG_WHOLE__
  move.l  D0,(A3)+            ; Funktionswert := 0
#else
  move.w  D0,(A3)+            ; Funktionswert := 0
#endif
#endif
  jmp     (A1)                ; zurueck zum Aufrufer
*)
 CODE(2063H);
 CODE(225FH);
 CODE(48D0H,0FAF8H);
 CODE(7000H);
#ifdef __RES_ON_STACK__
#ifdef __LONG_WHOLE__
 CODE(26C0H);
#else
 CODE(36C0H);
#endif
#endif
 CODE(4ED1H);
*)
END setjmp;
__PROCFRAME_ON__
(*----------------------------------------------------------------------------*)
__PROCFRAME_OFF__
PROCEDURE longjmp ((* EIN/ -- *) VAR env : JmpBuf;
                   (* EIN/ -- *)     val : INTEGER );
(**)
BEGIN
 IF MiNT THEN
   Psigreturn;
 END;
 ASSEMBLER
#ifdef __LONG_WHOLE__
   MOVE.L  -(A3),D0            ; D0 := <val>, Flags setzen
#else
   MOVE.W  -(A3),D0            ; D0 := <val>, Flags setzen
#endif
   MOVEA.L -(A3),A0            ; A0 -> <env>, Flags nicht veraendern
; Parameterstack abgeraeumt
   BNE.S   setregs             ; B: Wert <> Null uebernehmen
   MOVEQ   #1,D0               ; Wert Null auf eins korrigieren
setregs:
   MOVEM.L (A0),D3-D7/A1/A3-A7 ; Register auf Wert vor "setjmp()"
#ifdef __RES_ON_STACK__
#ifdef __LONG_WHOLE__
   MOVE.L  D0,(A3)+            ; Funktionswert := <val>
#else
   MOVE.W  D0,(A3)+            ; Funktionswert := <val>
#endif
#endif
   JMP     (A1)                ; zurueck wie nach "setjmp()"-Aufruf
 END;
(*
(*
longjmp:
#ifdef __LONG_WHOLE__
  move.l  -(A3),D0            ; D0 := <val>, Flags setzen
#else
  move.w  -(A3),D0            ; D0 := <val>, Flags setzen
#endif
  movea.l -(A3),A0            ; A0 -> <env>, Flags nicht veraendern
; Parameterstack abgeraeumt
  bne.s   setregs             ; B: Wert <> Null uebernehmen
  moveq   #1,D0               ; Wert Null auf eins korrigieren
setregs:
  movem.l (A0),D3-D7/A1/A3-A7 ; Register auf Wert vor "setjmp()"
#ifdef __RES_ON_STACK__
#ifdef __LONG_WHOLE__
  move.l  D0,(A3)+            ; Funktionswert := <val>
#else
  move.w  D0,(A3)+            ; Funktionswert := <val>
#endif
#endif
  jmp     (A1)                ; zurueck wie nach "setjmp()"-Aufruf
*)
#ifdef __LONG_WHOLE__
 CODE(2023H);
#else
 CODE(3023H);
#endif
 CODE(2063H);
 CODE(6602H);
 CODE(7001H);
 CODE(4CD0H,0FAF8H);
#ifdef __RES_ON_STACK__
#ifdef __LONG_WHOLE__
 CODE(26C0H);
#else
 CODE(36C0H);
#endif
#endif
 CODE(4ED1H);
*)
END longjmp;
__PROCFRAME_ON__

(*----------------------------------------------------------------------------*)


PROCEDURE sigsetjmp ((* -- /AUS *) VAR env      : SigJmpBuf;
                     (* EIN/ -- *)     savemask : UNSIGNEDWORD ): INTEGER;
(**)
BEGIN
 RETURN(-1);
END sigsetjmp;

(*----------------------------------------------------------------------------*)

PROCEDURE siglongjmp ((* EIN/ -- *) VAR env : SigJmpBuf;
                      (* EIN/ -- *)     val : INTEGER   );
(**)
BEGIN
END siglongjmp;


#elif (defined FTLM2)

PROCEDURE setjmp ((* -- /AUS *) VAR env : JmpBuf ): INTEGER;
(*T*)
BEGIN
(*
setjmp:
  movea.l (SP)+,A3         ; A3 -> globale Variablen des Aufrufers
  movea.l (SP)+,A6         ; A6 -> lokale Variablen des Aufrufers
  movea.l (SP)+,A1         ; A1 := RTN-Adresse
  movea.l (SP)+,A0         ; A0 -> <env>
; Parameter, Link und RTN-Adresse sind jetzt vom Stack abgeraeumt
  movem.l A1/A3/A6-A7,(A0) ; Register und RTN-Adr. in <env> sichern
  moveq   #0,D0            ; Funktionswert := 0;
  jmp     (A1)             ; zurueck zum Aufrufer
*)
 CODE(265FH);
 CODE(2C5FH);
 CODE(225FH);
 CODE(205FH);
 CODE(48D0H,0CA00H);
 CODE(7000H);
 CODE(4ED1H);
END setjmp;

(*----------------------------------------------------------------------------*)

PROCEDURE longjmp ((* EIN/ -- *) VAR env : JmpBuf;
                   (* EIN/ -- *)     val : INTEGER );
(*T*)
BEGIN
 IF MiNT THEN
   Psigreturn;
 END;
(*
longjmp:
  movea.l 8+2(A6),A0       ; A0 -> <env>
  move.w  8(A6),D0         ; D0 := <val>
  bne.s   setregs          ; B: Wert <> Null uebernehmen
  moveq   #1,D0            ; Wert Null auf eins korrigieren
setregs:
  movem.l (A0),A1/A3/A6-A7 ; Register auf Wert vor "setjmp()"
  jmp     (A1)             ; zurueck wie nach "setjmp()"-Aufruf
*)
 CODE(206EH,000AH);
 CODE(302EH,0008H);
 CODE(6602H);
 CODE(7001H);
 CODE(4CD0H,0CA00H);
 CODE(4ED1H);
END longjmp;

#elif (defined TSM2_1)
PROCEDURE setjmp ((* -- /AUS *) VAR env : JmpBuf ): INTEGER;
BEGIN
 RETURN(SetJmp(env));
END setjmp;

PROCEDURE longjmp ((* EIN/ -- *) VAR env : JmpBuf;
                   (* EIN/ -- *)     val : INTEGER );
BEGIN
 LongJmp(env, val);
END longjmp;

#else
#  error *** compiler not (yet) supported
#endif

(*===========================================================================*)

BEGIN (* jump *)
 MiNT := MiNTVersion() > 0;
END jump.
